Index: trunk/src/util/animation/animation3d.cc
===================================================================
--- trunk/src/util/animation/animation3d.cc	(revision 5108)
+++ trunk/src/util/animation/animation3d.cc	(revision 5110)
@@ -58,5 +58,5 @@
   // delete all the KeyFrames
   tIterator<KeyFrame3D>* itKF = keyFrameList->getIterator();
-  KeyFrame3D*  enumKF = itKF->nextElement();
+  KeyFrame3D*  enumKF = itKF->firstElement();
   while (enumKF)
     {
Index: trunk/src/util/animation/animation_player.cc
===================================================================
--- trunk/src/util/animation/animation_player.cc	(revision 5108)
+++ trunk/src/util/animation/animation_player.cc	(revision 5110)
@@ -86,5 +86,5 @@
   // deleting the Animation List AND all the elements of the List
   tIterator<Animation>* animIt = this->animationList->getIterator();
-  Animation* anim = animIt->nextElement();
+  Animation* anim = animIt->firstElement();
   while( anim != NULL)
     {
@@ -109,5 +109,5 @@
       // iterate through all the animations and tick them.
       tIterator<Animation>* animIt = this->animationList->getIterator();
-      Animation* anim = animIt->nextElement();
+      Animation* anim = animIt->firstElement();
       while( anim != NULL)
         {
@@ -147,5 +147,5 @@
 {
   tIterator<Animation>* animIt = this->animationList->getIterator();
-  Animation* anim = animIt->nextElement();
+  Animation* anim = animIt->firstElement();
   while( anim != NULL)
     {
@@ -176,5 +176,5 @@
   // Per ANIMATION DEBUG
   tIterator<Animation>* animIt = this->animationList->getIterator();
-  Animation* anim = animIt->nextElement();
+  Animation* anim = animIt->firstElement();
   while( anim != NULL)
     {
Index: trunk/src/util/animation/t_animation.h
===================================================================
--- trunk/src/util/animation/t_animation.h	(revision 5108)
+++ trunk/src/util/animation/t_animation.h	(revision 5110)
@@ -108,5 +108,5 @@
   // delete all the KeyFrames
   tIterator<KeyFrameF>* itKF = keyFrameList->getIterator();
-  KeyFrameF*  enumKF = itKF->nextElement();
+  KeyFrameF*  enumKF = itKF->firstElement();
   while (enumKF)
     {
Index: trunk/src/util/garbage_collector.cc
===================================================================
--- trunk/src/util/garbage_collector.cc	(revision 5108)
+++ trunk/src/util/garbage_collector.cc	(revision 5110)
@@ -156,5 +156,5 @@
 //
 //   tIterator<WorldEntity>* iterator = list->getIterator();
-//   WorldEntity* entity = iterator->nextElement();
+//   WorldEntity* entity = iterator->firstElement();
 //   while( entity != NULL)
 //     {
Index: trunk/src/util/loading/load_param.cc
===================================================================
--- trunk/src/util/loading/load_param.cc	(revision 5108)
+++ trunk/src/util/loading/load_param.cc	(revision 5110)
@@ -295,5 +295,5 @@
 
   tIterator<LoadParamDescription>* iterator = this->paramList->getIterator();
-  LoadParamDescription* enumParamDesc = iterator->nextElement();
+  LoadParamDescription* enumParamDesc = iterator->firstElement();
   while (enumParamDesc)
     {
@@ -314,5 +314,5 @@
 {
   tIterator<LoadClassDescription>* iterator = LoadClassDescription::classList->getIterator();
-  LoadClassDescription* enumClassDesc = iterator->nextElement();
+  LoadClassDescription* enumClassDesc = iterator->firstElement();
   while (enumClassDesc)
     {
@@ -336,5 +336,5 @@
 {
   tIterator<LoadParamDescription>* iterator = this->paramList->getIterator();
-  LoadParamDescription* enumParamDesc = iterator->nextElement();
+  LoadParamDescription* enumParamDesc = iterator->firstElement();
   while (enumParamDesc)
     {
@@ -362,10 +362,10 @@
   PRINT(3)(" Listing all the Loadable Options (loaded since Game started).\n\n");
   tIterator<LoadClassDescription>* classIT = LoadClassDescription::classList->getIterator();
-  LoadClassDescription* enumClassDesc = classIT->nextElement();
+  LoadClassDescription* enumClassDesc = classIT->firstElement();
   while (enumClassDesc)
     {
       PRINT(3)("<%s>\n", enumClassDesc->className);
       tIterator<LoadParamDescription>* paramIT = enumClassDesc->paramList->getIterator();
-      LoadParamDescription* enumParamDesc = paramIT->nextElement();
+      LoadParamDescription* enumParamDesc = paramIT->firstElement();
       while (enumParamDesc)
         {
@@ -394,5 +394,5 @@
 
   tIterator<LoadClassDescription>* iterator = LoadClassDescription::classList->getIterator();
-  LoadClassDescription* enumClassDesc = iterator->nextElement();
+  LoadClassDescription* enumClassDesc = iterator->firstElement();
   while (enumClassDesc)
   {
@@ -412,5 +412,5 @@
 // {
 //   tIterator<LoadClassDescription>* iterator = LoadClassDescription::classList->getIterator();
-//   LoadClassDescription* enumClassDesc = iterator->nextElement();
+//   LoadClassDescription* enumClassDesc = iterator->firstElement();
 //   while (enumClassDesc)
 //   {
Index: trunk/src/util/resource_manager.cc
===================================================================
--- trunk/src/util/resource_manager.cc	(revision 5108)
+++ trunk/src/util/resource_manager.cc	(revision 5110)
@@ -74,5 +74,5 @@
   // deleting the Directorie Lists
   tIterator<char>* tmpIt = imageDirs->getIterator();
-  char* tmpDir = tmpIt->nextElement();
+  char* tmpDir = tmpIt->firstElement();
   while(tmpDir)
     {
@@ -144,5 +144,5 @@
       // check if the Directory has been added before
       tIterator<char>* tmpImageDirs = imageDirs->getIterator();
-      char* tmpDir = tmpImageDirs->nextElement();
+      char* tmpDir = tmpImageDirs->firstElement();
       while(tmpDir)
         {
@@ -363,6 +363,5 @@
             {
               tIterator<char>* iterator = imageDirs->getIterator();
-              tmpDir = iterator->nextElement();
-              //tmpDir = imageDirs->enumerate();
+              tmpDir = iterator->firstElement();
               while(tmpDir)
                 {
@@ -492,5 +491,5 @@
 {
   tIterator<Resource>* iterator = resourceList->getIterator();
-  Resource* enumRes = iterator->nextElement();
+  Resource* enumRes = iterator->firstElement();
   while (enumRes)
     {
@@ -521,5 +520,5 @@
   //  Resource* enumRes = resourceList->enumerate();
   tIterator<Resource>* iterator = resourceList->getIterator();
-  Resource* enumRes = iterator->nextElement();
+  Resource* enumRes = iterator->firstElement();
   while (enumRes)
     {
@@ -603,5 +602,5 @@
   //  Resource* enumRes = resourceList->enumerate();
   tIterator<Resource>* iterator = resourceList->getIterator();
-  Resource* enumRes = iterator->nextElement();
+  Resource* enumRes = iterator->firstElement();
   while (enumRes)
     {
@@ -799,5 +798,5 @@
   PRINT(0)(" List of Image-Directories: ");
   tIterator<char>* tmpIt = imageDirs->getIterator();
-  char* tmpDir = tmpIt->nextElement();
+  char* tmpDir = tmpIt->firstElement();
   while(tmpDir)
     {
@@ -810,5 +809,5 @@
   PRINT(0)("List of all stored Resources:\n");
   tIterator<Resource>* iterator = resourceList->getIterator();
-  Resource* enumRes = iterator->nextElement();
+  Resource* enumRes = iterator->firstElement();
   while (enumRes)
     {
Index: trunk/src/util/shell.cc
===================================================================
--- trunk/src/util/shell.cc	(revision 5108)
+++ trunk/src/util/shell.cc	(revision 5110)
@@ -91,5 +91,5 @@
   // delete all the Chars in the Buffers
   tIterator<char>* charIterator = this->buffer->getIterator();
-  char* charElem = charIterator->nextElement();
+  char* charElem = charIterator->firstElement();
   while (charElem != NULL)
   {
@@ -191,5 +191,5 @@
   // delete all the Chars in the Buffers
   tIterator<char>* charIterator = this->buffer->getIterator();
-  char* charElem = charIterator->nextElement();
+  char* charElem = charIterator->firstElement();
 
   while (charElem != NULL)
@@ -289,5 +289,5 @@
 {
   tIterator<char>* charIterator = this->buffer->getIterator();
-  char* charElem = charIterator->nextElement();
+  char* charElem = charIterator->firstElement();
 
   int i = 1;
@@ -606,5 +606,5 @@
     addLength = strlen(addString);
   tIterator<const char>* charIterator = stringList->getIterator();
-  const char* charElem = charIterator->nextElement();
+  const char* charElem = charIterator->firstElement();
   while (charElem != NULL)
   {
@@ -655,5 +655,5 @@
 
   tIterator<const char>* iterator = inputList->getIterator();
-  const char* enumString = iterator->nextElement();
+  const char* enumString = iterator->firstElement();
   while (enumString != NULL)
   {
@@ -687,5 +687,5 @@
 
   tIterator<BaseObject>* iterator = inputList->getIterator();
-  BaseObject* enumBO = iterator->nextElement();
+  BaseObject* enumBO = iterator->firstElement();
   while (enumBO != NULL)
   {
Index: trunk/src/util/track/track_manager.cc
===================================================================
--- trunk/src/util/track/track_manager.cc	(revision 5108)
+++ trunk/src/util/track/track_manager.cc	(revision 5110)
@@ -79,5 +79,5 @@
     {
       tIterator<TrackElement>* iterator = this->children->getIterator();
-      TrackElement* enumElem = iterator->nextElement();
+      TrackElement* enumElem = iterator->firstElement();
       while (enumElem)
         {
@@ -104,5 +104,5 @@
     {
       tIterator<TrackElement>* iterator = this->children->getIterator();
-      TrackElement* enumElem = iterator->nextElement();
+      TrackElement* enumElem = iterator->firstElement();
       TrackElement* tmpElem;
       while (enumElem)
@@ -133,5 +133,5 @@
     {
       tIterator<TrackElement>* iterator = this->children->getIterator();
-      TrackElement* enumElem = iterator->nextElement();
+      TrackElement* enumElem = iterator->firstElement();
       TrackElement* tmpElem;
       while (enumElem)
@@ -179,5 +179,5 @@
     {
       tIterator<TrackElement>* iterator = this->children->getIterator();
-      TrackElement* enumElem = iterator->nextElement();
+      TrackElement* enumElem = iterator->firstElement();
       while (enumElem)
         {
@@ -206,5 +206,5 @@
 
   tIterator<TrackElement>* iterator = this->children->getIterator();
-  TrackElement* enumElem = iterator->nextElement();
+  TrackElement* enumElem = iterator->firstElement();
   for (int i = 0; i < childCount; i++)
     enumElem = iterator->nextElement();
@@ -234,5 +234,5 @@
       //TrackElement* enumElem = this->children->enumerate();
       tIterator<TrackElement>* iterator = this->children->getIterator();
-      TrackElement* enumElem = iterator->nextElement();
+      TrackElement* enumElem = iterator->firstElement();
       while (enumElem)
         {
@@ -331,5 +331,5 @@
   //TrackElement* enumElem = this->children->enumerate();
   tIterator<TrackElement>* iterator = this->children->getIterator();
-  TrackElement* enumElem = iterator->nextElement();
+  TrackElement* enumElem = iterator->firstElement();
   while (enumElem)
     {
@@ -975,5 +975,5 @@
       //TrackElement* enumElem = firstJoint->children->enumerate();
       tIterator<TrackElement>* iterator = firstJoint->children->getIterator();
-      TrackElement* enumElem = iterator->nextElement();
+      TrackElement* enumElem = iterator->firstElement();
       while (enumElem)
         {
@@ -1001,5 +1001,5 @@
         {
           tIterator<TrackElement>* iterator = tmpElem->children->getIterator();
-          TrackElement* enumElem = iterator->nextElement();
+          TrackElement* enumElem = iterator->firstElement();
           //TrackElement* enumElem = tmpElem->children->enumerate();
           while (enumElem)